cfetApp.CFETModule.controller('AgentenController',
    function ($scope, $modal, cfService, $location, cfClient, $interval, $q, map2DimArrayFilter) {
        // fix rotation sizes
        var w = window.innerWidth;
        var h = window.innerHeight;

        // po


        var maxWidth = w;
        $scope.maxWidth = maxWidth;
        $scope.maxHeight = h - 57;

        jQuery('body').css({'background-color': 'white'});


        var cfUser = cfService.getUser();

        $scope.checkingForUpdates = true;
        $scope.downloadsInProgress = false;
        $scope.offline = false;
        $scope.missing = 0;
        $scope.clientlist = [];

        var downloader = cfService.getPictureDownloader();
        $scope.downloadsInProgress = downloader.downloadsInProgress() > 0;

        var updateTimerPromise;

        function fail() {
            console.log("failed op", arguments);
            $scope.clientlist = [];
        }

        // 1. lade das lokal gespeichert zeugs zu erst einmal
        cfService.getClientList().then(successLocalLoad, fail);

        function successLocalLoad(list) {
            console.log("loaded list", list);

            $scope.clientlist = list;
            $scope.clienttable = map2DimArrayFilter(list);


            // offline fall
            if (cfService.isOffline()) {
                $scope.offline = true;
                $scope.downloadsInProgress = false;
                // urls testen der bereits heruntergeladenen bilder
                checkDownloads(list).then(function(data) {
                    $scope.clientlist = data.clientlist;
                    $scope.clienttable = map2DimArrayFilter(data.clientlist);
                    cfService.setClientList(data.clientlist);
                    $scope.checkingForUpdates = false;
                });



            } else if ($scope.downloadsInProgress) {
                $scope.offline = false;
            } else {
                // 2. lade die Liste vom Server falls man online ist
                cfClient.getClientList().then(successOnline, fail);

                // TODO: ueberzaehlige loeschen
            }

        }


        function successOffline(list) {
        }


        function successOnline(list) {
            console.log("fetched list", list);

            //TEST
            /*
            if(list.length % 3 == 0) {
                list.push({
                    displayName: 'test',
                    profileId: 1,
                    fotoCount: 0,
                    playlistCount: 0
                });
            }
            */

            // TEST
            //list = [];

            $scope.clientlist = list;
            $scope.clienttable = map2DimArrayFilter(list);

            // pruefe die Profilbilder
            checkDownloads(list).then(
                function (data) {
                    $scope.clientlist = data.clientlist;
                    $scope.clienttable = map2DimArrayFilter(data.clientlist);
                    $scope.checkingForUpdates = false;
                    console.log("missing profilepics", data.missing);

                    // neue liste speichern
                    cfService.setClientList(data.clientlist);

                    // fehlende herunterladen
                    doDownloads(data.missing);
                },
                function (error) {
                    console.log("error", error);
                }
            );


        }

        function checkDownloads(list) {
            var idx = 0;
            var def = $q.defer();
            var missing = [];

            function doItem() {
                if (idx == list.length) {
                    def.resolve({clientlist: list, missing: missing});
                    return;
                }

                var client = list[idx];
                idx++;
                if (client.foto && client.foto.length > 0) {
                    var pic = client.foto[0];

                    cfService.isProfilePictureDownloaded(pic.fotoId).then(function (fileEntry) {
                        client.profilePicDownloaded = true;
                        client.profilePicImgUrl = fileEntry.toURL();

                        // iOS6 quirks: cordova.file.dataDirectory ist mit file://localhost/... was dann einen FileError.ENCODING_ERROR verursacht
                        client.profilePicImgUrl = client.profilePicImgUrl.replace(/file:\/\/localhost\//, 'file:///');

                        client.showSpinner = false;
                        // TEST
                        if(cfService.isDevMode()) {
                            client.profilePicImgUrl = cfService.getPictureDownloadUrl(pic.fotoId, pic.auth, 240);
                        }
                        doItem();
                    }, function () {
                        client.profilePicDownloaded = false;
                        client.showSpinner = true;
                        missing.push(pic);
                        doItem();
                    });
                } else {
                    doItem();
                }
            }

            doItem();

            return def.promise;
        }


        function doDownloads(missing) {
            function successCB(fileEntry, pic) {
                var imgUrl = fileEntry.toURL();

                // iOS6 quirks: cordova.file.dataDirectory ist mit file://localhost/... was dann einen FileError.ENCODING_ERROR verursacht
                imgUrl = imgUrl.replace(/file:\/\/localhost\//, 'file:///');

                // TEST
                if(cfService.isDevMode()) {
                    imgUrl = cfService.getPictureDownloadUrl(pic.fotoId, pic.auth, Math.max(window.innerHeight, window.innerWidth));
                }
                // find pic in list
                for (var k = 0; k < $scope.clientlist.length; k++) {
                    if(!$scope.clientlist[k].foto || $scope.clientlist[k].foto.length == 0) {
                        continue;
                    }
                    if ($scope.clientlist[k].foto[0].fotoId == pic.fotoId) {
                        $scope.clientlist[k].profilePicDownloaded = true;
                        $scope.clientlist[k].profilePicImgUrl = imgUrl;
                        $scope.clientlist[k].showSpinner = false;
                        break;
                    }
                }


            };
            function failureCB(error, pic) {
                console.log('failed');
                //download failed
                // find pic in list
                for (var k = 0; k < $scope.clientlist.length; k++) {
                    if(!$scope.clientlist[k].foto || $scope.clientlist[k].foto.length == 0) {
                        continue;
                    }
                    if ($scope.clientlist[k].foto[0].fotoId == pic.fotoId) {
                        $scope.clientlist[k].profilePicDownloaded = false;
                        $scope.clientlist[k].profilePicDownloadError = true;
                        $scope.clientlist[k].showSpinner = false;
                        break;
                    }
                }
            };

            cfService.downloadProfilePictures(missing, successCB, failureCB);
        }


        $scope.navToStart = function () {
            console.log("nav to start");

            $location.path('/startseite');
        };


    }
);