cfetApp.CFETModule.controller('BilderController',
    function ($scope, $modal, cfService, $location, cfClient, $interval, $q, $routeParams) {
        // fix rotation sizes
        var w = window.innerWidth;
        var h = window.innerHeight;
        var maxWidth = w;
        $scope.maxWidth = maxWidth;
        $scope.maxHeight = h;

        jQuery('html, body').css('overflow', 'initial');


        var cfUser = cfService.getUser();

        $scope.checkingForUpdates = true;
        $scope.downloadsInProgress = false;
        $scope.offline = false;
        $scope.missing = 0;

        $scope.missingVideos = [];
        $scope.playlist = [];
        $scope.profileId = cfUser.getProfileId();
        $scope.clientView = false;
        if($routeParams.profileId > 0) {
            $scope.clientDisplayName = $routeParams.displayName;
            $scope.clientView = true;
            $scope.profileId = $routeParams.profileId;
        }

        var downloader = cfService.getPictureDownloader();
        $scope.downloadsInProgress = downloader.downloadsInProgress() > 0;


        var updateTimerPromise;

        function fail() {
            console.log("failed op", arguments);
            $scope.piclist = [];
        }

        // zeige eine evtl. gespeicerte lokale liste von bildern
        cfService.getPictureListByProfileId($scope.profileId).then(successLocalLoad, fail);


        function enableDynamicNav() {

            // unbind scroll event
            jQuery(document).off('scrollstop');
            jQuery(document).off('scrollstart');

            var timeout;
            var showtime = 2000;
            // navigation ausblenden
            jQuery(document).on('scrollstart', function(e) {
                window.clearTimeout(timeout);
                jQuery('.dynamicControl').show();
            });
            jQuery(document).on("scrollstop", function (e) {
                window.clearTimeout(timeout);
                timeout =  window.setTimeout(function() {
                    jQuery('.dynamicControl').fadeOut('slow');
                }, showtime);
            });

            timeout =  window.setTimeout(function() {
                jQuery('.dynamicControl').fadeOut('slow');
            }, showtime);
        }


        function successLocalLoad(list) {
            console.log("loaded list", list);

            // unbind scroll event
            jQuery(document).off('scrollstop');
            jQuery(document).off('scrollstart');


            if(list.length > 0) {
                enableDynamicNav();
            }



            checkDownloads(list).then(
                function (data) {
                    $scope.piclist = data.piclist;
                    console.log("missing", data.missing);

                    // liste speichern
                    cfService.setPictureListForProfileId($scope.profileId, data.piclist);


                    // offline fall
                    if (cfService.isOffline()) {
                        $scope.offline = true;
                        $scope.downloadsInProgress = false;
                        $scope.checkingForUpdates = false;



                        // das war es dann

                    } else if ($scope.downloadsInProgress) {
                        $scope.offline = false;
                        $scope.checkingForUpdates = false;



                    } else {

                        // ueberpruefe ob der Server neue/andere Bilder hat
                        cfClient.getPictureListByProfileId($scope.profileId).then(successOnline, fail);

                        // TODO: ueberzaehlige loeschen
                    }


                },
                function (error) {
                    console.log("error", error);
                }
            );



        }

        function successOnline(list) {
            console.log("fetched list", list);

            // TEST
            //list = [];

            checkDownloads(list).then(
                function (data) {
                    $scope.piclist = data.piclist;
                    //console.log("missing", data.missing);
                    $scope.checkingForUpdates = false;

                    // liste speichern
                    cfService.setPictureListForProfileId($scope.profileId, data.piclist);


                    if(list.length > 0) {
                        enableDynamicNav();
                    }

                    // fehlende herunterladen
                    doDownloads(data.missing);
                },
                function (error) {
                    console.log("error", error);
                }
            );
        }


        function checkDownloads(list) {
            var idx = 0;
            var def = $q.defer();
            var missing = [];

            function doItem() {
                if (idx == list.length) {
                    def.resolve({piclist: list, missing: missing});
                    return;
                }

                var pic = list[idx];
                idx++;

                cfService.isPictureDownloaded(pic.fotoId).then(function (fileEntry) {
                    pic.imageUrl = fileEntry.toURL();

                    // iOS6 quirks: cordova.file.dataDirectory ist mit file://localhost/... was dann einen FileError.ENCODING_ERROR verursacht
                    pic.imageUrl = pic.imageUrl.replace(/file:\/\/localhost\//, 'file:///');

                    // TEST
                    if(cfService.isDevMode()) {
                        pic.imageUrl = cfService.getPictureDownloadUrl(pic.fotoId, pic.auth, Math.max(window.innerHeight, window.innerWidth));
                    }

                    pic.downloaded = true;

                    doItem();
                }, function () {
                    pic.downloaded = false;

                    missing.push(pic);
                    doItem();
                });
            }

            doItem();

            return def.promise;
        }


        function doDownloads(missing) {
            var h = window.innerHeight;
            var w = window.innerWidth;
            // immer in max. Groesse laden
            var maxHeight = Math.max(h, w);
            if (window.devicePixelRatio > 1) {
                // support retina und so
                maxHeight = maxHeight * window.devicePixelRatio;
            }

            for (var i = 0; i < missing.length; i++) {
                (function () {
                    // extra scope for promise handler
                    var pic = missing[i];

                    var dlConfig = {
                        sourceUrl: cfService.getPictureDownloadUrl(pic.fotoId, pic.auth, maxHeight),
                        targetPath: cfService.getDataDirUrl() + '/picture-' + pic.fotoId + ".jpg",
                        data: pic,
                        options: {},
                        defer: $q.defer()
                    };

                    dlConfig.defer.promise.then(function (fileEntry) {
                        var imgUrl = fileEntry.toURL();
                        // iOS6 quirks: cordova.file.dataDirectory ist mit file://localhost/... was dann einen FileError.ENCODING_ERROR verursacht
                        imgUrl = imgUrl.replace(/file:\/\/localhost\//, 'file:///');

                        // TEST
                        if(cfService.isDevMode()) {
                            imgUrl = cfService.getPictureDownloadUrl(pic.fotoId, pic.auth, Math.max(window.innerHeight, window.innerWidth));
                        }
                        // find pic in list
                        for (var k = 0; k < $scope.piclist.length; k++) {
                            if ($scope.piclist[k].fotoId == pic.fotoId) {
                                $scope.piclist[k].imageUrl = imgUrl;
                                $scope.piclist[k].downloaded = true;
                                // force digest
                                //$scope.$apply();
                                break;
                            }
                        }


                    }, function () {
                        console.log('failed');
                        // download failed
                        // find pic in list
                        for (var k = 0; k < $scope.piclist.length; k++) {
                            if ($scope.piclist[k].fotoId == dlConfig.fotoId) {
                                $scope.piclist[k].downloaded = false;
                                $scope.piclist[k].downloadError = true;
                                // force digest
                                //$scope.$apply();
                                break;
                            }
                        }
                    });
                    var dlRef = cfService.getPictureDownloader().queueDownload(dlConfig);
                    console.log("queued dl", dlRef, dlConfig);
                })();
            }
        }

        $scope.navToStart = function() {
            jQuery('html, body').css('overflow', 'hidden');
            if($scope.clientView) {
                console.log("nav to clientlist");
                $location.path('/klienten');
            } else {
                console.log("nav to start");
                $location.path('/startseite');
            }

        };


    }
);