cfetApp.CFETModule.controller('LoginCheckController',
    function ($scope, cfClient, cfService, $location, $modal, $rootScope, $timeout) {
        // fix rotation sizes
        var w = window.innerWidth;
        var h = window.innerHeight;

        jQuery('.fullScreen').css({'background-color': 'white'});
        jQuery('body').css({'background-color': 'white'});


        // check persisted user
        cfService.resurrectUser().then(function (cfUser) {

            // persisted user haben immer den app-enabled status


            console.log("resurrected user: uid=" + cfUser.getUserId(), cfUser);
            cfService.setUser(cfUser);
            cfClient.setCredentials(cfUser.getUserId(), '');
            //cfClient.setSessionId(info.sessionId);
            //cfClient.setXSRFToken(info.xsrfToken);
            //cfClient.setRememberMeToken(info.remToken);

            // im Online Fall den App Status ueberpruefen
            if(cfService.isOnline()) {
                console.log("device is online, checking account")
                cfClient.getLoginStatus().then(function(info) {
                    console.log("remeber login successful", info);

                    var cfu = info.user;

                    // check user ids
                    if(cfu.getUserId() != cfUser.getUserId()) {
                        console.log("user id mismatch");
                        $location.path('/login');
                        return;
                    }

                    // app feature
                    if(!cfUser.isAppEnabled()) {
                        $scope.msgHeaderKey = 'fehler';
                        $scope.msgBodyKey = 'app_feature_not_enabled';
                        var popup = $modal.open({
                            templateUrl: 'app/template/alertDialog.html',
                            size: 'sm',
                            scope: $scope,
                            backdrop: false
                        });

                        // remove eventually stored user
                        cfService.forgetUser();

                        popup.result.then(function() {
                            $location.path('/login');
                        }, function() {
                            $location.path('/login');
                        });
                        return;
                    }


                    // TEST
                    //$location.path('/login');
                    //return;


                    $location.path('/startseite');

                }, function() {
                    console.log("remember login failed");
                    $location.path('/login');
                });


            } else {
                console.log("device is offline, continue to app start");
                $location.path('/startseite');
            }
        }, function () {
            console.log("failed to resurrect user", arguments);
            $location.path('/login');
        });

    }
);


