cfetApp.CFETModule.controller('LoginController', ['$scope', 'cfClient', 'cfService', '$location', '$modal', '$rootScope', '$timeout',
    function ($scope, cfClient, cfService, $location, $modal, $rootScope, $timeout) {



        // evtl. ein fehlgeschlagener remeber me login
        var resurrectedUser = cfService.getUser();
        $scope.resurrectedUserId = '';
        if(resurrectedUser) {
            $scope.resurrectedUserId = resurrectedUser.getUserId();
        }
        $scope.username = '';

        // TEST
        //$scope.username = 'tschauspielerzwei'; //testing
        // TEST
        // $scope.username = 'bdohmenbeispiel'; //testing
        // TEST
        //$scope.username = 'tagent'; //testing
        // TEST
        //$scope.password = 'apple1234';

        $scope.doLogin = function () {

            var uid = $scope.username + '';
            if(resurrectedUser) {
                uid = resurrectedUser.getUserId();
            }
            var pw = $scope.password + '';

            if(cfService.isOffline()) {
                $scope.msgHeaderKey = 'fehler';
                $scope.msgBodyKey = 'device_is_offline';
                $modal.open({
                    templateUrl: 'app/template/alertDialog.html',
                    size: 'sm',
                    scope: $scope,
                    backdrop: true
                });

                return;
            }


            if(!uid || uid == 'undefined') {
                $scope.msgHeaderKey = 'fehler';
                $scope.msgBodyKey = 'login_error_check_username_or_password';
                $modal.open({
                    templateUrl: 'app/template/alertDialog.html',
                    size: 'sm',
                    scope: $scope,
                    backdrop: true
                });
                return;
            }

            if(!pw  || pw == 'undefined') {
                $scope.msgHeaderKey = 'fehler';
                $scope.msgBodyKey = 'login_error_check_username_or_password';
                $modal.open({
                    templateUrl: 'app/template/alertDialog.html',
                    size: 'sm',
                    scope: $scope,
                    backdrop: true
                });
                return;
            }

            $scope.startTime = new Date().getTime();

            $scope.waiterDlg = $modal.open({
                templateUrl: 'app/template/loginInProgressDialog.html',
                size: 'sm',
                scope: $scope,
                backdrop: false
            });
            var p = cfClient.authenticate(uid, pw, $rootScope.i18n.lng);
            $scope.waiterDlg.result.then(function(msg) {
                console.log("closed dlg: " + msg)
            }, function(msg ) {
                console.log("dismissed dlg " + msg);
                p.cancel();
            });


            function error() {
                console.error("authen failed", arguments);
                var stopTime = new Date().getTime();
                $timeout(function () {
                        $scope.waiterDlg.close('error');
                        $scope.msgHeaderKey = 'login_failed';
                        $scope.msgBodyKey = 'login_error_check_username_or_password';
                        $modal.open({
                            templateUrl: 'app/template/alertDialog.html',
                            size: 'sm',
                            scope: $scope,
                            backdrop: false
                        });

                    },
                    Math.max(1000 - (stopTime - $scope.startTime), 0));
            }

            p.then(success, error).finally(function() {
                // statusbar keeps open on android
                StatusBar.hide();
            });
        };

        function success(info) {
            console.log("user=", info);
            var cfUser = info.user;

            if(!cfUser.isAppEnabled()) {
                $scope.waiterDlg.close('error');
                $scope.msgHeaderKey = 'fehler';
                $scope.msgBodyKey = 'app_feature_not_enabled';
                $modal.open({
                    templateUrl: 'app/template/alertDialog.html',
                    size: 'sm',
                    scope: $scope,
                    backdrop: false
                });

                // remove eventually stored user
                cfService.forgetUser();
                cfService.setUser(null);

                return;
            }


            cfClient.setCredentials(cfUser.getUserId(), '');
            cfClient.setSessionId(info.sessionId);
            cfClient.setXSRFToken(info.xsrfToken);
            cfClient.setRememberMeToken(info.remToken);
            cfService.setUser(cfUser);
            cfService.saveUser();

            console.log("authen ok", arguments);

            if($scope.waiterDlg) {
                var stopTime = new Date().getTime();
                $timeout(function () {
                        $scope.waiterDlg.close('success');
                        $location.path('/startseite');
                    },
                    Math.max(1000 - (stopTime - $scope.startTime), 0));
            } else {
                $location.path('/startseite');
            }
        }

        $scope.openPasswordReset = function() {
            cfService.openPasswordReset();
        }

        $scope.openRegistration = function() {
            cfService.openRegisterPage();
        }

    }]);