cfetApp.CFETModule.controller('ShowreelController',
    function ($scope, $modal, cfService, $location, cfClient, $interval, $routeParams) {
        // fix rotation sizes
        var w = window.innerWidth;
        var h = window.innerHeight;

        var cfUser = cfService.getUser();

        $scope.checkingForUpdates = true;
        $scope.downloadsInProgress = false;
        $scope.offline = false;
        $scope.missing = 0;
        $scope.clientView = false;
        $scope.profileId = cfUser.getProfileId();
        $scope.video = {};

        if($routeParams.profileId > 0) {
            $scope.clientDisplayName = $routeParams.displayName;
            $scope.clientView = true;
            $scope.profileId = $routeParams.profileId;
        }

        $scope.missingVideos = [];
        $scope.playlist = [];

        var videoDownloader = cfService.getVideoDownloader();
        $scope.downloadsInProgress = videoDownloader.downloadsInProgress() > 0;
        $scope.downloadsInProgressCount = videoDownloader.downloadsEnqueued();

        var updateTimerPromise;

        // offline fall
        if(cfService.isOffline()) {
            $scope.offline = true;
            cfService.getVideoListByProfileId($scope.profileId).then(successOffline, fail);
        } else if(false && $scope.downloadsInProgress) {

            //$scope.checkingForUpdates = false;
            // wenn downloads aktiv nicht noch einmal die liste vom server holen
            cfService.getVideoListByProfileId($scope.profileId).then(successOffline, fail);
            // starte den updater wieder
            downloadProgressUpdater();
            updateTimerPromise = $interval(downloadProgressUpdater, 1000);
        } else {
            // online fall

            // erst die vorhandene List laden

            // dann online nachschauen

            cfClient.getVideoListByProfileId($scope.profileId).then(successOnline, fail);
            if($scope.downloadsInProgressCount > 0) {
                downloadProgressUpdater();
                $interval.cancel(updateTimerPromise);
                updateTimerPromise = $interval(downloadProgressUpdater, 1000);
            }

        }

        function successOffline(list) {
            checkDownloads(list, function(playList, missing) {
                $scope.playlist = playList;
                $scope.checkingForUpdates = false;
            });
        }


        function successOnline(list) {
            // TEST
            /*
            for(var i = 0; i< 50; i++) {
                list.push({
                    videoId: i,
                    title: 'tester',
                    year: 2014,
                    director: 'Someone'

                });
            }
            */

            // TEST
            //list = [];

            $scope.playlist = list;

                // finde die nicht lokalen videos
                checkDownloads(list, function (playList, missing) {
                    // speichere Liste
                    cfService.setVideoListForProfileId($scope.profileId, playList).then(
                        function() {
                            $scope.playlist = playList;
                            $scope.missing = missing.length;
                            $scope.checkingForUpdates = false;
                            $scope.missingVideos = missing;
                            downloadProgressUpdater();
                        }
                    );
                });
        }

        function checkDownloads(list, successCB) {
            var missing = [];
            var idx = 0;
            var action = function() {
                if(idx == list.length) {
                    successCB(list, missing);
                    return;
                }

                var vid = list[idx];
                //test
                //vid.year = '2014';
                //vid.director = 'James Cameron, Tim und Struppy, Wolfgang Menge';
                //if(idx % 2 == 0) {
                //    vid.director = 'Miss Marple';
                //}


                cfService.isVideoDownloaded(vid.videoId).then(function() {
                    vid.downloaded = true;
                    action(++idx);
                }, function() {
                    vid.downloaded = false;
                    // check if video is already queued for download
                    var downloads = cfService.getVideoDownloader().getDownloadStatus();
                    var queued = false;
                    for(var i = 0; i < downloads.length; i++) {
                        var videoInfo = downloads[i].data;

                        var status = downloads[i].dlStatus;
                            if(vid.videoId == videoInfo.videoId) {
                                // is queued
                                queued = true;
                               break;
                        }
                    }
                    console.log("queued=" + queued);
                    if(!queued) {
                        missing.push(vid);
                    }
                    action(++idx);
                });
            };

            action();
        }

        function fail() {
            $scope.playlist = [];
        }


        function isInlineView() {
            return jQuery('#videoplayercontainer').is(":visible") === true;
        }


        $scope.doPlayVideo = function(video) {

            function showVideo(url) {

                // iOS6 quirks: cordova.file.dataDirectory ist mit file://localhost/... was dann einen FileError.ENCODING_ERROR verursacht
                url = url.replace(/file:\/\/localhost\//, 'file:///');


                if (isInlineView()) {
                    $scope.doShowVideo(url);
                } else {
                    $scope.doPlayVideoExternal(video);
                }
            };

            cfService.isVideoDownloaded(video.videoId).then(
                function(videoFileEntry) {
                    console.log("video is local", videoFileEntry);
                    // play from local
                    var url = videoFileEntry.toURL();
                    showVideo(url);
                },
                function() {
                    if(cfService.isOffline()) {
                        $scope.msgHeaderKey = 'fehler';
                        $scope.msgBodyKey = 'no_offline_video_stream_message';
                        var modal = $modal.open({
                            templateUrl: 'app/template/alertDialog.html',
                            size: 'sm',
                            scope: $scope,
                            backdrop: true
                        });


                        return;
                    }

                    // stream from internet
                    var url = cfService.getVideoStreamUrl(video.videoId, video.auth);
                    console.log("streaming from " + url);
                    showVideo(url);

                });


        };

        $scope.doShowVideo = function(url) {


            $('.mejs-container').remove();


            var videoWidth = $('#videoplayercontainer').width()
            var videoHeight = $('#videoplayercontainer').height();
            console.log("videoW=" + videoWidth + ", videoH=" + videoHeight);
            var jv = $('<video>', {id: 'v1', src: url, width: videoWidth + 'px', height: videoHeight + 'px', controls: "controls", preload: 'auto', autoplay: 'autoplay', type: 'video/mp4'});

            $('#videoplayercontainer').append(jv);
            /*
            diese events kommen nicht
            jv.on('canplay load loaded', function() {
                console.log("trigger play", arguments);
                $('video')[0].play();
            });
            */

            var videoOptions = {
                features: ['playpause','progress','current', 'duration','fullscreen'],
                alwaysShowControls: false,
                mode: 'native',
                videoWidth: videoWidth,
                videoHeight: videoHeight,
                iPadUseNativeControls: false,
                iPhoneUseNativeControls: false,
                AndroidUseNativeControls: false,
                success: function(mediaElement, node, mediaPlayer) {
                    console.log("success");
                    console.log(arguments);
                    mediaElement.play();
                    mediaPlayer.setPlayerSize(videoWidth, videoHeight);

                    app.setMediaPlayer(mediaPlayer);
                },
                error: function() {
                    console.log('ERROR');
                    console.log(arguments);
                }
            };
            jv.mediaelementplayer(videoOptions);


            window.setTimeout(function() {
                var vid = $('video')[0];
                if(vid.paused) {
                    console.log("video is still paused, trigger play");
                    $('video')[0].play();
                } else {
                    console.log("video is already playing");
                }
            }, 1000);

            return;



        };




        $scope.doPlayVideoExternal = function(video) {
            var url = '/videoplayer/' + encodeURIComponent(video.videoId) +
                '/' + encodeURIComponent(video.auth) +
                '/' + encodeURIComponent(video.title);

            if($scope.clientView) {
                url = url +
                    '/' + encodeURIComponent($scope.profileId) +
                    '/' + encodeURIComponent($scope.clientDisplayName);
            } else {
                url = url + '/0/x';
            }
            console.log('url=' + url);
            $interval.cancel(updateTimerPromise);
            $location.path(url);
        };

        $scope.startDownloads = function() {

            var size = 0;
            for(var i = 0; i < $scope.playlist.length; i++ ) {
                if(!$scope.playlist[i].downloaded) {
                    size += $scope.playlist[i].filesize;
                }
            }

            var mbsize = Math.floor(size / MB_IN_BYTES);

            $scope.videoSizeMB = mbsize;

            var modal = $modal.open({
                templateUrl: 'app/template/startDownloadDialog.html',
                size: 'sm',
                scope: $scope,
                backdrop: false
            });
            modal.result.then(function() {
                // start download
                $scope.downloadsInProgress = true;
                $scope.downloadsInProgressCount = cfService.getVideoDownloader().downloadsEnqueued();
                cfService.downloadVideos($scope.missingVideos);
                $interval.cancel(updateTimerPromise);
                updateTimerPromise = $interval(downloadProgressUpdater, 1000);

                //TODO: ueberzaehlige loeschen
            });
        };

        $scope.cancelDownloads = function() {
            var modal = $modal.open({
                templateUrl: 'app/template/stopDownloadDialog.html',
                size: 'sm',
                backdrop: false
            });
            modal.result.then(function() {
                // stop download
                $scope.downloadsInProgress = false;
                $interval.cancel(updateTimerPromise);
                cfService.getVideoDownloader().cancelDownloads(true);
                downloadProgressUpdater();
                $scope.downloadsInProgressCount = 0;

                //recalc missing

                // finde die nicht lokalen videos
                var list = $scope.playlist;
                checkDownloads(list, function (playList, missing) {
                            $scope.playlist = playList;
                            $scope.checkingForUpdates = false;
                            $scope.missingVideos = missing;
                            for(var k = 0; k < $scope.playlist.length; k++) {
                                delete $scope.playlist[k].dlStatus;
                                delete $scope.playlist[k].dlPercent;
                            }

                            calcMissingDownloadsOfPlaylist();
                            $scope.downloadsInProgressCount = 0;

                });


            });
        };

        $scope.navToStart = function() {
            $interval.cancel(updateTimerPromise);
            app.setMediaPlayer(null);
            jQuery('video').stop();
            $('.mejs-container').remove();

            if($scope.clientView) {
                console.log("nav to clientlist");
                $location.path('/klienten');
            } else {
                console.log("nav to start");
                $location.path('/startseite');
            }

        };

        function downloadProgressUpdater() {
            var downloads = cfService.getVideoDownloader().getDownloadStatus();
            var pending = 0;
            var queuedOfPlaylist = 0

            for(var i = 0; i < downloads.length; i++) {
                var videoInfo = downloads[i].data;
                var percent = downloads[i].dlPercent;
                var status = downloads[i].dlStatus;


                if(status == 'AVAILABLE' || status == 'STARTED') {
                    pending++;
                }

                // update knob
                jQuery('#downloadProgressIndicator-' + videoInfo.videoId).knob();
                jQuery('#downloadProgressIndicator-' + videoInfo.videoId).show();

                if(status == 'STARTED') {
                    jQuery('#downloadProgressIndicator-' + videoInfo.videoId).val(percent).trigger('change');
                }


                // find video in list with looping
                for(var k = 0; k < $scope.playlist.length; k++) {
                    if($scope.playlist[k].videoId === videoInfo.videoId) {
                        $scope.playlist[k].dlPercent = percent;
                        $scope.playlist[k].dlStatus = status;
                        if(status == 'COMPLETED') {
                            $scope.playlist[k].downloaded = true;
                        }
                        queuedOfPlaylist++;

                        break;
                    }
                }
            }

            if(pending == 0) {
                $interval.cancel(updateTimerPromise);
                $scope.downloadsInProgress = false;
            }

            calcMissingDownloadsOfPlaylist();
            $scope.downloadsInProgressCount = videoDownloader.downloadsEnqueued();
        }


        function calcMissingDownloadsOfPlaylist() {
            // calc missing downloads of this playlist
            var downloads = cfService.getVideoDownloader().getDownloadStatus();
            var missing = $scope.playlist.length;
            for(var k = 0; k < $scope.playlist.length; k++) {
                if($scope.playlist[k].downloaded) {
                    missing--;
                    continue;
                }
                for(var i = 0; i < downloads.length; i++) {
                    if ($scope.playlist[k].videoId === downloads[i].data.videoId) {
                        missing--;
                        break;
                    }
                }
            }
            console.log("missing downloads of playlist:" + missing);
            $scope.missing = missing;
        }
    }
    );