cfetApp.CFETModule.controller('VideoController',
    function ($scope, $modal, cfService, $location, $routeParams, $q) {
        // fix rotation sizes

        $scope.videoId = $routeParams.videoId;
        $scope.auth = $routeParams.auth;
        $scope.hasVideo = false;
        $scope.videoTitle = $routeParams.title;

        console.log($routeParams);

        cfService.isVideoDownloaded($scope.videoId).then(
            function(videoFileEntry) {
                console.log("video is local", videoFileEntry);
                // play from local
                var url = videoFileEntry.toURL();

                // iOS6 quirks: cordova.file.dataDirectory ist mit file://localhost/... was dann einen FileError.ENCODING_ERROR verursacht
                url = url.replace(/file:\/\/localhost\//, 'file:///');
                showVideo(url);

            },
            function() {
                // stream from internet
                var url = cfService.getVideoStreamUrl($scope.videoId, $scope.auth);
                console.log("streaming from " + url);
                showVideo(url);

            }
        );


        function showVideo(url) {
            console.log("video with url=" + url);


            $('.mejs-container').remove();


            var videoWidth = $('#videoPlayerFull').width()
            var videoHeight = $('#videoPlayerRow').height();
            console.log("videoW=" + videoWidth + ", videoH=" + videoHeight);
            var jv = $('<video>', {id: 'v2', src: url, width: videoWidth + 'px', height: videoHeight + 'px', controls: "controls", preload: 'auto', autoplay: 'autoplay', type: 'video/mp4'});

            $('#videoPlayerFull').append(jv);
            jv.on('canplay load loaded', function() {
                console.log("trigger play", arguments);
                $('video')[0].play();
            });

            var videoOptions = {
                features: ['playpause','progress','current', 'duration','fullscreen'],
                alwaysShowControls: false,
                mode: 'native',
                videoWidth: videoWidth,
                videoHeight: videoHeight,
                iPadUseNativeControls: false,
                iPhoneUseNativeControls: false,
                AndroidUseNativeControls: false,
                fullscreen: true,
                success: function(mediaElement, node, mediaPlayerElement) {
                    console.log("success");
                    console.log(arguments);
                    //mediaElement.play();
                    //var mp = new MediaElementPlayer('#v1');
                    mediaPlayerElement.setPlayerSize(videoWidth, videoHeight);
                    app.setMediaPlayer(mediaPlayerElement);
                    $('.mejs-fullscreen-button button')[0].click();
                },
                error: function() {
                    console.log('ERROR');
                    console.log(arguments);
                }
            };
            jv.mediaelementplayer(videoOptions);


            window.setTimeout(function() {
                console.log('video play timed 1');
                //$('video')[0].play();
            }, 1000);

        }

        $scope.navToShowreel = function() {
            console.log("nav to showreel");
            // video beenden
            jQuery('video').stop();
            $('.mejs-container').remove();
            app.setMediaPlayer(null);
            jQuery('video').remove();
            var url = '/showreel/' + encodeURIComponent($routeParams.profileId) + '/' + encodeURIComponent($routeParams.displayName);
            $location.path(url);
        }
    }
);
