
function CFUser(config) {
    // just debug as private data
    this.initConfig = config;

    this.firstName = config.gn;
    this.lastName = config.sn;
    this.type = config.type;
    this.userId = config.username;
    this.capabilities = config.accountingRights;
    this.profileLink = config.profileLink;
    this.profileId = config.profileId;

    return this;
}

CFUser.prototype.getUserId = function() {
    return this.userId;
};

CFUser.prototype.getProfileLink = function() {
    return this.profileLink;
};

CFUser.prototype.getProfileId = function() {
    return this.profileId;
};

CFUser.prototype.getInitConfig = function() {
    return this.initConfig;
};

CFUser.prototype.hasCapability = function(capability) {

    return this.capabilities[capability];
};

CFUser.prototype.hasRole = function(role) {
    if(ROLE_ACTOR === role) {
        if(this.type == USER_TYPE_ACTOR) {
            return true;
        }
    }
    if(ROLE_AGENT === role) {
        if(this.type == USER_TYPE_AGENT) {
            return true;
        }
    }
    if(ROLE_CASTER === role) {
        if(this.type === USER_TYPE_CASTER || this.type === USER_TYPE_REGISSEUR || this.type === USER_TYPE_PRODUCER) {
            return true;
        }
    }
    return false;
};

CFUser.prototype.isActor = function() {
    return this.hasRole(ROLE_ACTOR);
};


CFUser.prototype.isCaster = function() {
    return this.hasRole(ROLE_CASTER);
};

CFUser.prototype.isAgent = function() {
    return this.hasRole(ROLE_AGENT);
};

CFUser.prototype.isAppEnabled = function() {
    //TEST
    // return false;
    return this.hasCapability(CAPABILITY_APP);
};
