cfetApp.CFETModule = angular.module('CFETApp', ['ngCordova','ngRoute', 'ngTouch', 'ngCookies', 'ui.bootstrap'] );



cfetApp.CFETModule.config(['$routeProvider',
    function ($routeProvider) {
        $routeProvider.
            when('/logincheck', {
                templateUrl: 'app/template/logincheck.html',
                controller: 'LoginCheckController'
            }).
            when('/login', {
                templateUrl: 'app/template/login.html',
                controller: 'LoginController'
            }).
            when('/startseite', {
                templateUrl: 'app/template/startseite.html',
                controller: 'StartseiteController'
            }).
            when('/showreel/:profileId/:displayName', {
                templateUrl: 'app/template/showreel.html',
                controller: 'ShowreelController'
            }).
            when('/videoplayer/:videoId/:auth/:title/:profileId/:displayName', {
                templateUrl: 'app/template/videoplayer.html',
                controller: 'VideoController'
            }).
            when('/bilder/:profileId/:displayName', {
                templateUrl: 'app/template/bilder.html',
                controller: 'BilderController'
            }).
            when('/klienten', {
                templateUrl: 'app/template/klienten.html',
                controller: 'AgentenController'
            }).
            otherwise({
                redirectTo: '/logincheck'
            });
    }]);

cfetApp.CFETModule.factory('cfClient', ['$http', '$q', '$cookies', function($http, $q, $cookies) {

    var config = {
        baseUrl: 'https://v2.castforward.de',
        //baseUrl: 'http://192.168.3.101',
        jsonRPCEndpoint: '/gateway/jsonGateway.php',
        httpClient: $http,
        q: $q,
        cookies: $cookies
    };

    // TEST fix
    var m = window.location.href.match(/(192\.168\.\d+\.\d+)/);
    if(m) {
        config.baseUrl = 'http://'+ m[0];
        config.devMode = true;
    }


    var client = new CFClient(config);

    return client;
} ]);


cfetApp.CFETModule.factory('cfService', function(cfClient, $cordovaFile, $cordovaDevice, $q ) {
    var networkState = navigator.connection.type;
    var offline = networkState === Connection.NONE;


    var config = {
        baseUrl: 'https://v2.castforward.de',
        //baseUrl: 'http://192.168.3.101',
        cfClient: cfClient,
        fileService: $cordovaFile,
        deviceService: $cordovaDevice,
        q: $q,
        availableLanguageIds: [ 'de', 'en', 'fr', 'it', 'es', 'ru'],
        offline: offline,
        validScanLinkRegexes: [
            /^https?:\/\/(\w+\.)?lment\.de/i,
            /^https?:\/\/(\w+\.)?e-talenta\.eu/i,
            /^https?:\/\/(\w+\.)?castforward\.de/i
        ]
    };

    // TEST fix
    var m = window.location.href.match(/(192\.168\.\d+\.\d+)/);
    if(m) {
        config.baseUrl = 'http://'+ m[0];
        config.devMode = true;
    }

    var cfService = new CFService(config);

    document.addEventListener('offline', function() {
        cfService.setOffline();
    }, false);

    document.addEventListener('online', function() {
        cfService.setOnline();
    }, false);

    // kick off translation downloads
    cfService.downloadTranslationUpdates();

    return cfService;
});

cfetApp.CFETModule.filter('map2DimArray', function() {
   var filterFunc = function(inList) {
       var mapped = [];

       var cols = 2;
       var i = 0;
       while(i < inList.length) {
           var col = [];
            for(var c = 0; c < cols && i < inList.length; c++) {
                col.push(inList[i++]);
            }
           mapped.push(col);
       }
       //console.log("mapped:", mapped);
       return mapped;
   } ;

   return filterFunc;
});
